#!/bin/bash
# mmm2html.sh -- shell script wrapping the conversion the MM
#                manual into a set of HTML2 files
#
# Copyright (C) 1995 MID/Information Logistics Group
#
# This file is part of the MetaMorphosis SGML conversion system.

FILES='../bin/mmx ../bin/mmsgmls ./CATALOG ./sb.dcl ./manual.sgm ../samples/sb2html.mmx'

for F in $FILES; do
  if ! [ -f $F ] ; then  
    echo "couldn't find required file $F"; 
    echo "make sure you are in .../mm/doc and try again."
    exit 1; 
  fi
done

echo "parsing manual.sgm ..."

# run MetaMorphosis on the manual
../bin/mmsgmls ./sb.dcl manual.sgm | ../bin/mmx -X ../samples/sb2html.mmx -S - -F txt -T -

if [ $? -eq 0 ]; then 
  # /tmp is the factory setting for OUTDIR in sb2html.mm
  cp graphics/* /tmp
  echo "conversion finished."
  echo "point your Web browser at the file >>>> /tmp/toc.html <<<<"
fi
