// Copyright (C) 1995 MID/Information Logistics Group
// This file is part of the MetaMorphosis SGML conversion system.
//
// mmdialog.h
//
// Starts a conversation with the user each time DIALOG(...) is called.
// First, the contents (...) is packed in a temporary target node
// called <TMP.DIALOG>, then this target node is replaced by the
// contents resulting from the dialog, whereby (...) is the default
// contents.
//
// Usage:
//    #include "mmdialog.h"
//    !TRANSFORMATION
//    e [] MM_DIALOG(...);
//

#ifndef MM_PATH
#define MM_PATH(c) join(reverse(this,ancestor)[c].id,"/")
#endif
#ifndef MM_TUMBLER
#define MM_TUMBLER(c) join(reverse(this,ancestor)[c].(count(left[c])+1),".")
#endif

#define MM_DIALOG(c) <|tmp.dialog|>self{c}

!TRANSFORMATION

tmp.dialog
   [] !replace
      (*here := p) & null
     ,(*contents := contents.(p | this)) & null
     ,p.(MM_PATH() || " [" || MM_TUMBLER() || "] (" || key || ")\n: ").echo()
     ,file()[!until parse("") |
                    parse("([iI] ?%)^ @?")
                        .(*again := 1,
                          (*contents := *here:1.evaluate(that) |
                                        "Warning: contents deleted\n".echo()
                         )) |
                    parse("([aA] ?%)^ @?")
                        .(*again := 1,
                          (*contents := (*contents
                                        ,*here:1.evaluate(that) |
                                         "Warning: contents unchanged\n".echo()
                         ))             )
            ]
           .((parse("[qQ]")
                  .exit(0)
             ,parse("\\?")
                  .(("Commands available:\n"
                    ," -         insert contents and continue\n"
                    ," - i ...   make ... the new contents of the target-node\n"
                    ," - a ...   add ... to the contents of the target-node\n"
                    ," - g ...   goto ... (i.e., goto some node in some tree)\n"
                    ," - b [N]   go back N (otherwise 1) goto-step(s)\n"
                    ," - w       where am I?\n"
                    ," - h       show goto-history\n"
                    ," - d [...] dump tree(s) ... (otherwise 'this')\n"
                    ," - e ...   display (sort of) expression image\n"
                    ," - $ ...   execute shell command ...\n"
                    ," - ?       help\n"
                    ," - q       quit\n"
                    ).echo() | 1)
             ,parse("($ ?%)^ @?")
                  .((execute() || "\n").echo() | 1)
             ,parse("([gG] ?%)@!")
                  .(*here := (*here:1.evaluate(that):1[key] |
                              "Error: must go to tree-node\n".echo()
                             ,*here
                             ))
             ,parse("([bB]%)@?")
                  .(*here := *here:(nummax((this, 1)) + 1)~0 | *here:-1)
             ,parse("([gG] ?^ @?|[bB]@?|[wW])%1|[hH]%0")
                  .(reverse(*here:1~(this))
                          .(" -> " || (sourcename || " " | "") ||
                            MM_PATH() || " [" || MM_TUMBLER() || "] (" ||
                                         key || ")\n"
                           ).echo() | 1)
             ,parse("([dD] ?%)^ @?|[dD] ?%this")
                  .(*here:1.evaluate(that).dumptree() | 1)
             ,parse("([eE] ?%)^ @?")
                  .(image(*here:1.evaluate(that))
                  .(" => " || this || "\n").echo() | 1)
             ) | "???\n".echo() & null
            ,": ".echo()
            )
     ,*again & MM_DIALOG(*contents) | *contents;
