//
// mmlib.h -- standard definitions
//
// Copyright (C) 1995 MID/Information Logistics Group
// This file is part of the MetaMorphosis SGML conversion system.
//
//
// Usage:
//    #include "mmlib.h"
//

#ifndef MM_PATH
#define MM_PATH(c) join(reverse(this,ancestor)[c].id,"/")
#endif
#ifndef MM_TUMBLER
#define MM_TUMBLER(c) join(reverse(this,ancestor)[c].(count(left[c])+1),".")
#endif

//

#define MM_ALPHABET "ABCDEFGHIJKLMNOPQRSTUVWXYZ"

//

#define MM_LPAD(s,l) (s).(join((" ".duplicate((l)-that.length()),this)))
#define MM_RPAD(s,l) (s).(join((this," ".duplicate((l)-that.length()))))

//

#define MM_ESCAPE(x) (x).parse("(^[#:]!|@.{c}%{c}{c})*")

//

#define MM_GETSIZE(s) ((s).(this * parse("([0-9.]!%)@?").lowercase()\
                               .((this == "mm"               & r47.244094) |\
                                 (this == "cm"               & r472.44094) |\
                                 (this == "dm"               & r4724.4094) |\
                                 (this ==  "m"               & r47244.094) |\
                                 (this == ("p","pt","point") & r16.6044) |\
                                 (this == ("bp","bpt","bpoint") & r16.6667) |\
                                 (this == ("pc","pica")      & r199.2528) |\
                                 (this == ("cc","cicero")    & r213.2022) |\
                                 (this == ("dd","ddp","ddpoint") & r17.76685) |\
                                 (this == ("sp","spt","spoint") & r0.0002533) |\
                                 (this == ("i","in","inch")  & r1200.00))\
                        ))

#define MM_SETSIZE(s,u) (((s) / (u).lowercase()\
                            .((this == "mm"               & r47.244094) |\
                              (this == "cm"               & r472.44094) |\
                              (this == "dm"               & r4724.4094) |\
                              (this ==  "m"               & r47244.094) |\
                              (this == ("p","pt","point") & r16.6044) |\
                              (this == ("bp","bpt","bpoint") & r16.6667) |\
                              (this == ("pc","pica")      & r199.2528) |\
                              (this == ("cc","cicero")    & r213.2022) |\
                              (this == ("dd","ddp","ddpoint") & r17.76685) |\
                              (this == ("sp","spt","spoint") & r0.0002533) |\
                              (this == ("i","in","inch")  & r1200.00))\
                      ).parse("[0-9]?(\\.0?%|\\.@*^0(0?%))") || (u))

//

#define MM_TNODE(t,n) tree(t).node(that.(n))

//

#define MM_REGULAR(p) ((p):1.(parse("(\\*%@*|\\?%@|[a-zA-Z]!|(%\\\\)@)*") | \
                              ("Illegal regular expression: " || this || "\n") \
                             .forceerror(2,"ILLEGALREGULAR")))
